#include <clientapi.h>
#include "filehead.h"
#include "changesorter.h"
#include "filelogcache.h"

int main (int argc, char** argv)
{
	StrBuf path;
	if (argc == 2) path.Set(argv[1]);
	else return 1;
	ClientApi client;
	Error e;
	FileLogCache* cache = new FileLogCache(path, &client, &e);
	FileHead* fhead = cache->head;
	FileRev* frev;
	FileRevArrow* farrow;
	while ( fhead )
	{
		frev = fhead->head;
		while (frev)
		{
			printf( "	AddRev( \"%s\", %s, %s, ", fhead->name.Text(), frev->rev.Text(), frev->change.Text() );
			switch( frev->type )
			{
			case ADD:
				printf( "RRadd" ); break;
			case BRANCH:
				printf( "RRbranch" ); break;
			case DEL:
				printf( "RRdelete" ); break;
			case EDIT:
			default:
				printf( "RRedit" ); break;
			case INTEG:
				printf( "RRinteg" ); break;
			}
			printf( " );\n" );
			frev = frev->next;
		}
		fhead = fhead->next_into;
	}
	fhead = cache->head;
	while ( fhead )
	{
		frev = fhead->head;
		while (frev)
		{
			char* ritype;
			farrow = frev->fromarrows;
			while (farrow)
			{
				switch ( farrow->type )
				{
				case branch:
					ritype = "RIbranch"; break;
				case copy:
					ritype = "RIcopy"; break;
				case edit:
					ritype = 0x0; break;
				case ignore:
					ritype = "RIignore"; break;
				case impure:
					ritype = "RIedit"; break;
				case merge:
				default:
					ritype = "RImerge"; break;
				}
				if ( !ritype )
				{
					farrow = farrow->next;
					continue;
				}
				printf( "	AddInteg( \"%s\", %s, \"%s\", %s, %s );\n",
					farrow->ptr->fh->name.Text(), farrow->ptr->rev.Text(),
					fhead->name.Text(), frev->rev.Text(), ritype );
				farrow=farrow->next;
			}
			frev = frev->next;
		}
		fhead = fhead->next_into;
	}

	StrBuf msg;
	if( e.Test() )
	{
	    e.Fmt( &msg );
	    fprintf( stderr, "%s\n", msg.Text() );
	    return 1;
	}
	return 0;
}